#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define TK_ZERO 0
#define TK_ONE  1
#define TK_BLANK 2
#define TK_END 3
#define TK_ERROR 4

char *data;
char *dataStart;
char gByte[8];
char gBytePos = 0;
unsigned char *buff;
int buffMax = 0;
int buffSize;
int line = 0;
int column = 0;
char errorchar;
int error = 0;

inline int ReadBlank()
{
start:
	while (*data == ' ' || *data == '\t' || 
		*data == '\r' || *data == '\n')
		if (*data++ == '\n')
		{
			line++;
			column = 0;				
		}
		else
			column++;
			
	if (*data == '#')
	{
		while (*data && *data != '\n')
			*data++;
		goto start;	
	}
}

inline int NextToken()
{
	if (!*data)
		return TK_END;
	column++;

	switch (*data++)
	{
	case '0':
		return TK_ZERO;
	case '1':
		return TK_ONE;
	case '\n':
	case ' ': case '\t':
	case '\r':
		ReadBlank();
		return TK_BLANK;
	default:
		errorchar = data[-1];
		return TK_ERROR;
	}
} 

inline void Bit()
{
	switch (NextToken())
	{
	case TK_ZERO:
		gByte[gBytePos++] = '0';
		break;
	case TK_ONE:
		gByte[gBytePos++] = '1';
		break;
	default:
		error = 1;
		if (*data)
			printf(" %d  %d УЧţ%c\n", line + 1, column, errorchar);
		break;
	}
}

inline void Byte()
{
	Bit(), Bit(), Bit(), Bit();
	Bit(), Bit(), Bit(), Bit();
	if (gBytePos == 8)
	{
		gBytePos = 0;
		if (buffSize == buffMax)
			buff = realloc(buff, buffMax <<= 1);
		unsigned char *p = &buff[buffSize++];
		*p = 0;
		for (int i = 7; i >= 0; i--)
			*p |= (gByte[i] - 48) << 7 - i;
	}
}

void Data()
{
	ReadBlank();
	do {
		Byte();
		ReadBlank();
	} while (!error && *data == '0' || *data == '1');

	if (NextToken() != TK_END)
		printf(" %d У﷨\n", line + 1);
}

char * LoadFile(char *path)
{
	FILE *fp = fopen(path, "rb");
	if (!fp)
		return NULL;
	fseek(fp, 0, SEEK_END);
	int size = ftell(fp);
	fseek(fp, 0, SEEK_SET);
	char *data = malloc(size + 1);	
	fread(data, size, 1, fp);
	data[size] = '\0';
	fclose(fp);
	return data;
}

int ConvertToBinaryFile(char *srcPath, char *newPath, int alignNum)
{
	FILE *fSrc = fopen(srcPath, "rb");
	FILE *fNew = fopen(newPath, "wb");
	
	if (!fSrc || !fNew)
		return 0;
	int alen = 0;
	int aMax = 0;
	char (*array)[8] = malloc(sizeof(*array) * (aMax = 2));

	fseek(fSrc, 0, SEEK_END);
	int size = ftell(fSrc);
	fseek(fSrc, 0, SEEK_SET);
	char *data = malloc(size);	
	fread(data, size, 1, fSrc);
	fclose(fSrc);

	for (int i = 0; i < size; i++)
	{
		char ch = *data++;
		if (alen == aMax)
			array = realloc(array, sizeof(*array) * (aMax <<= 1));
		char *arr = array[alen++];
		for(int j = 0; j < 8; j++)
		{
			arr[j] = ch & 0x80 ? '1' : '0';  
			ch <<= 1;
		}
	}
	
	for (int i = 0; i < alen;)
	{
		fwrite(array[i], sizeof(*array), 1, fNew);
		if (++i % alignNum == 0)
			fwrite("\r\n", sizeof("\r\n") - 1, 1, fNew); 
		else
			fwrite(" ", sizeof(" ") - 1, 1, fNew);
	}

	fclose(fNew);
	return 1;
}

int main(int argc, char *argv[])
{
	if (argc <= 1 || argc != 4)
	{
		printf(">> Ա뷴 1.0\n>> Copyright (C) 2017\n");
		printf("------------------------\n");
		printf(">> ʹ˵\n");
		printf("------------------------\n");
		printf("ƣ\t-b2f <Դļλ> <ļλ>\n");
		printf("ƣ\t-f2b <Դļλ> <ļλ>\n");
		return 0;
	} 

	if (strcmp(argv[1], "-b2f") == 0)
	{
		dataStart = data = LoadFile(argv[2]);
		if (!data)
		{
			printf("ȡļ %sʧܡ", argv[2]); 
			return 0;
		}
		buff = calloc(1, buffMax = 2);	
		Data();
		free(dataStart);
		if (!error)
		{
			FILE *fp = fopen(argv[3], "wb");
			if (!fp)
			{
				printf("ļ %sʧܡ", argv[3]);	
				return 0;
			}
			fwrite(buff, buffSize, 1, fp);
			fclose(fp);
			printf("ɹ");
		}
		free(buff);
	}
	else if (strcmp(argv[1], "-f2b") == 0)
	{
		if (!ConvertToBinaryFile(argv[2], argv[3], 8))
			printf("ļʧܡ");
		else
			printf("ɹ");
	}
	else
		printf("Чָ%s ", argv[1]);
	return 0;
}

